
; The  Emulator (C) 1989-91 Todor Todorov
; Bootstrap loader and block device drivers

; 29 Sep 1991
; 16 Oct 1991

	.radix	16

swib	=	5
swia	=	6

resetsp =	0e67bh
resetsv =	0e67c

drvcnt	=	0e677
drvxlat =	0e678

jmpadr	=	0e67e

fdcstat =	0e6d0
rompage =	0e6f0

xtmp	=	0ed6bh

resetp	=	0ed80
resetv	=	0ee02

	.model	tiny
	.code

cal	macro	adrs
	db	0ce, 0c0, low adrs		;LDX   #adrs
	db	0ff, high jmpadr, low jmpadr	;STX   $E67E
	endm

	org	100

start:
	dw	0a55a				;ROM header
	db	'EMULATOR'
	db	7e, 0c0, low init		;JMP   INIT
	db	7e, 0c0, low main		;JMP   MAIN

	db	17
	db	0c0, low loint
	db	0

hdr	db	0c0, low hinit
	db	0c0, low hread
	db	0c0, low hwrit

init:
	cal	initdo
main:
	db	39				;RTS

reset:
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	db	31				;INS
	cal	boot
patch:
	db	24, quit-$-1			;BCC   quit
	db	0b6, high drvcnt, low drvcnt	;LDAA  drvcnt
	db	27, jmpdos-$-1			;BEQ   jmpdos
drvlup:
	db	5f				;CLRB
	db	0ce, 2, 5dh			;LDX   #$25D
	db	3f, 2a				;INT   $2A
	db	3f, 2c				;INT   $2C
	db	0f				;SEI
	db	0ff, high xtmp, low xtmp	;STX   xtmp
	cal	move_hdr_go
	db	36				;PSHA
	db	0fe, high xtmp, low xtmp	;LDX   xtmp
	db	0e				;CLI
	db	0f6, high rompage, low rompage	;LDAB  $E6F0
	db	3f, 5dh 			;INT   $5D
	db	32				;PULA
	db	4a				;DECA
	db	26, drvlup-$-1			;BNE   drvlup
	db	86, 2				;LDAA  #2
	db	3f, 44				;INT   $44
jmpdos:
	db	7e, 10, 0			;JMP   $1000
quit:
	db	3f, 0				;INT   $00

hinit:
	db	7f, 0, 6			;CLR	$06
	db	39				;RTS

hread:
	db	86, 1				;LDAA  #1
	db	27

hwrit:
	db	4f				;CLRA
	db	0f				;SEI
	db	0ff, high xtmp, low xtmp	;STX	xtmp
	cal	read_writ_go
	db	39				;RTS

loint:
	db	0f				;SEI
	db	0ff, high xtmp, low xtmp	;STX   xtmp
	cal	lobios_go
	db	39				;RTS

move_hdr_go:
	jmp	move_hdr

read_writ_go:
	jmp	read_writ

initdo:
	mov	ax,(low (reset-start)) * 100 + 0c0
	xchg	ax,ds:[resetv]
	mov	ds:[resetsv],ax
	mov	al,ds:[rompage]
	xchg	al,ds:[resetp]
	mov	ds:[resetsp],al
	iret

boot_fail:
	xor	byte ptr ds:[patch+0bf00],1
	iret
boot:
	cld
	mov	ax,ds:[resetsv]
	mov	ds:[resetv],ax
	mov	al,ds:[resetsp]
	mov	ds:[resetp],al
	mov	byte ptr ds:[0],0
	mov	byte ptr ds:[fdcstat],80
	call	init_hdr
	call	move_name
	mov	ax,3d00
	int	21
	jc	boot_fail
	xchg	ax,bx
	mov	dx,1000
	mov	cx,0b000
	mov	ah,3f
	int	21
	mov	ah,3e
	int	21
	iret

lobios_go:
	jmp	lobios

	.errnz	($-start)/100

init_hdr:
	xor	si,si
	mov	ah,30
	int	21
	cmp	al,4
	jc	go_lup
	inc	si
go_lup:
	push	ds
	pop	es
	mov	di,drvxlat
	mov	dl,3
drv_lup:
	mov	ah,32
	int	21
	test	al,al
	jnz	nxt_drv
	cmp	byte ptr [bx+si+16],0f8
	jnz	nxt_drv
	cmp	[bx+0dh],0ff6
	jnc	nxt_drv
	cmp	[bx+2],200
	jnz	nxt_drv
	cmp	[bx+7],al
	jnz	nxt_drv
	inc	byte ptr es:[drvcnt]
	mov	al,dl
	stosb
	cmp	di,drvxlat+6
	jz	drv_full
nxt_drv:
	inc	dx
	cmp	dl,1bh
	jnz	drv_lup
drv_full:
	push	es
	pop	ds
	ret

move_hdr:
	cld
	mov	ax,ds:[xtmp]
	xchg	al,ah
	xchg	ax,di
	mov	bl,ds:[drvcnt]
	sub	bh,bh
	sub	bl,dh
	sbb	bh,bh
	mov	dl,[bx+drvxlat]
	mov	si,offset hdr+0bf00
	push	ds
	pop	es
	movsw
	movsw
	movsw
	inc	di
	lea	ax,[di+56]
	xchg	al,ah
	stosw
	lea	ax,[di+12]
	xchg	al,ah
	stosw
	add	di,3
	mov	ah,32
	int	21
	lea	si,[bx+2]
	lodsw
	xchg	al,ah
	stosw
	lodsw
	inc	ax
	stosb
	lodsw
	stosb
	movsb
	lodsw
	xchg	al,ah
	stosw
	lodsw
	xchg	ax,dx
	lodsw
	dec	ax
	mov	cl,[bx+5]
	shl	ax,cl
	add	ax,dx
	xchg	al,ah
	stosw
	mov	al,0f8
	stosb
	movsb
	xor	ax,ax
	stosw
	push	es
	pop	ds
	iret

read_writ:
	mov	ax,ds:[xtmp]
	xchg	al,ah
	xchg	ax,di
	mov	bx,drvxlat
	mov	al,[di+2]
	mov	ah,2
	sub	al,ah
	cmp	al,ds:[drvcnt]
	jnc	set_err
	xlat
	dec	ax
	mov	bx,[di]
	xchg	bl,bh
	shr	dh,1
	mov	dx,[di+3]
	xchg	dl,dh
	mov	cx,1
	jnc	do_writ
	int	25
	jmp	short rw_done
do_writ:
	int	26
rw_done:
	pop	bx
	jnc	no_err
	mov	ah,6
	test	al,0c2
	jnz	set_err
	mov	ah,4
	test	al,38
	jnz	set_err
	mov	ah,5
	test	al,4
	jnz	set_err
	mov	ah,3
	test	al,1
	jnz	set_err
no_err:
	xor	ah,ah
set_err:
	mov	ds:[swia],ah
	iret

lobios:
	mov	ax,ds:[xtmp]
	xchg	al,ah
	xchg	ax,di
	mov	ah,dh
	mov	bp,3
	and	ah,7f
	jnz	no_reset
	xor	dl,dl
call_it:
	push	ax
	push	es
	push	ds
	pop	es
	mov	al,1
	int	13
	pop	es
	pop	si
	jnc	no_err_go
	dec	bp
	jz	set_err
	xchg	ax,si
	jmp	call_it
no_err_go:
	mov	ds:[swib],ch
	jmp	no_err
no_reset:
	mov	dl,[di]
	test	dl,dl
	jz	disk_ok
	push	ax
	int	11
	test	al,1
	jz	disk_bad
	test	al,0c0
disk_bad:
	pop	ax
	jz	err_now
disk_ok:
	mov	ch,[di+1]
	mov	dh,[di+2]
	mov	cl,[di+3]
	mov	bx,[di+4]
	xchg	bl,bh
	inc	ah
	jo	no_err
	cmp	ah,4
	jc	call_it
	jz	no_err
err_now:
	mov	ah,20
	jmp	set_err

move_name:
	mov	ah,30
	int	21
	mov	di,offset namebuf+0bf00
	mov	dx,di
	cmp	al,3
	jc	no_name
	mov	ah,62
	int	21
	mov	ds,bx
	mov	ds,ds:[2c]
	xor	si,si
scan_env:
	lodsw
	dec	si
	test	ax,ax
	jnz	scan_env
	add	si,3
	call	move_str
	sub	di,0bh
	push	cs
	pop	ds
no_name:
	mov	si,offset dosname+0bf00
move_str:
	lodsb
	stosb
	test	al,al
	jnz	move_str
	ret

dosname db	'UNIDOS.BIN',0

	db	0fa				;Checksum

namebuf db	51 dup(?)

	end	start
